import java.awt.*; 
import java.awt.image.*; 
import java.io.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 

import Acme.JPM.Encoders.*; 

public class GreyScaleServlet extends HttpServlet { 

	public void doGet (HttpServletRequest req, HttpServletResponse res) 
                   							throws ServletException, IOException { 
	  res.setContentType("image/gif"); 
	  ServletOutputStream out = res.getOutputStream(); 

	  // zskame info o umiestnen obrzku 
	  String source = req.getPathTranslated(); 
	  if (source == null) { 
	   throw new ServletException("Chyba v umiestnen obrzku"); 
	  } 

	  /* vytvorme viacnsobne pouiten frame, priom 
	  tentokrt nepotrebujeme vola metdu addNotify() */ 
	  Frame frame = new Frame();
	  
	  // natiahneme obrzok do pamte 
	  Image image = Toolkit.getDefaultToolkit().getImage(source); 
	  MediaTracker mt = new MediaTracker(frame); 
	  mt.addImage(image, 0); 
	  try { 
	   mt.waitForAll(); 
	  } 
	  catch (InterruptedException e) { 
	   getServletContext().log("Chyba pri natan obrzka", e); 
	   throw new ServletException(e.getMessage()); 
	  } 

	  // zistme rozmery obrzku 
	  int width = image.getWidth(frame); 
	  int height = image.getHeight(frame); 
	
	  // obrzok preenieme cez filter 
	  Image filtered = frame.createImage(new FilteredImageSource(image.getSource(),new GreyScaleFilter())); 

	  // obrzok zakdujeme a poleme 
	  GifEncoder encoder = new GifEncoder(filtered, out); 
	  encoder.encode(); 
	} 
} 