import java.awt.*; 
import java.awt.image.*; 
import java.io.*; 
import java.util.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 

import Acme.JPM.Encoders.*; 

public class GreyScaleServletCached extends HttpServlet { 

	// vytvorme hash tabuku
	Hashtable gifs = new Hashtable();

	public void doGet (HttpServletRequest req, HttpServletResponse res) 
                   							throws ServletException, IOException { 
	  res.setContentType("image/gif"); 
	  ServletOutputStream out = res.getOutputStream(); 

	  // zskame info o umiestnen obrzku 
	  String source = req.getPathTranslated(); 
	  if (source == null) { 
	   throw new ServletException("Chyba v umiestnen obrzku"); 
	  } 
	  
	  // ak skonvertovan obrzok existuje, poleme ho
	  if (gifs.containsKey(source)) {
		ByteArrayOutputStream baos = (ByteArrayOutputStream) gifs.get(source);
		baos.writeTo(out);
	    return;
	  }
	  
	  /* vytvorme viacnsobne pouiten frame, priom 
	  tentokrt nepotrebujeme vola metdu addNotify() */ 
	  Frame frame = new Frame();
	  
	  // natiahneme obrzok do pamte 
	  Image image = Toolkit.getDefaultToolkit().getImage(source); 
	  MediaTracker mt = new MediaTracker(frame); 
	  mt.addImage(image, 0); 
	  try { 
	   mt.waitForAll(); 
	  } 
	  catch (InterruptedException e) { 
	   getServletContext().log("Chyba pri natan obrzka", e); 
	   throw new ServletException(e.getMessage()); 
	  } 

	  // zistme rozmery obrzku 
	  int width = image.getWidth(frame); 
	  int height = image.getHeight(frame); 
	
	  // obrzok preenieme cez filter 
	  Image filtered = frame.createImage(new FilteredImageSource(image.getSource(),new GreyScaleFilter()));
	  
	  // obrzok zakdujeme, ulome do Hashtable a poleme 
	  ByteArrayOutputStream baos = new ByteArrayOutputStream();
	  GifEncoder encoder = new GifEncoder(filtered, baos);
	  encoder.encode();
	  gifs.put(source, baos);
	  baos.writeTo(out);
	} 
} 